#!/usr/bin/python

__doc__ = "XMLRPCProxy Base Classes"
__version__ = "0.0.2"

import xmlrpclib, string

class XMLRPCProxyBase:
   """
   Base Class for the Zope XML-RPC Proxy Product
   """
   def __init__(self, url, ValidMethodList=[]):

	self.url = url
	self.ValidMethodList = ValidMethodList

   def _getRemoteMethodObject(self, methodname):
	# We recreate the object every time because the user could change 
	# the URL on the fly through the management interface
	#
	# down the road we may not want to do this if performance becomes
	# a major issue.  The server object cannot be pickled anyway, so it's
	# not a big deal to recreate it for each request
	#
	if methodname:
		splitmethod = string.split(methodname, "/")
		methodparent = string.join(splitmethod[:-1], "/")
		realmethodname = splitmethod[-1:][0]
		fullurl = self.url + methodparent

	s = xmlrpclib.Server(fullurl)

	return eval("s." + realmethodname)

   def _ConvertURLToMethod(self, methodname):
	methodname = string.replace(methodname, "/", ".")
	return methodname

   def callRemoteMethod(self, methodname, *args):
	
	if self.ValidMethodList:
	   for allowed_method in self.ValidMethodList:
		if ( methodname == allowed_method ):
			remotemethodobject = self._getRemoteMethodObject(methodname)
			return apply(remotemethodobject, args)

	return "Error: You are not allowed to execute the method %s" % methodname


